/*
   (c) 2021 Christian Grieger
   GNU GENERAL PUBLIC LICENSE
*/

#ifndef HOUSELIGHTING_H
#define HOUSELIGHTING_H

#include <Arduino.h>

class HouseLighting
{
  public:
    /**
       Constructor which resets all relevant values and connects the LED to the pin of the Arduino.

           ledPin        Number of the pin to be connected on the Arduino
           timeOn        Seconds how long the light will stay turned ON
           timeOff       Seconds how long the light will stay turned OFF
           initialState  Which LED state to start with (ON or OFF)
    */
    HouseLighting (byte ledPin, int timeOn, int timeOff, byte initialState);

    /**
       Update routine which should be called in the main loop()-function
    */
    void update();

    static const byte OFF;
    static const byte ON;

  protected:
    byte pin;
    byte currentState;
    int delays[2];
    long nextAction;
};

#endif
